/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import org.tranql.field.Row;
import org.tranql.identity.IdentityDefiner;
import org.tranql.ql.Query;
import org.tranql.ql.QueryException;
import org.tranql.query.QueryCommand;
import org.tranql.query.ResultHandler;

/**
 *
 *
 *
 * @version $Revision: 323 $ $Date: 2006-02-19 01:29:24 -0500 (Sun, 19 Feb 2006) $
 */
public final class CacheLoadCommand implements QueryCommand {
    private final QueryCommand next;
    private final IdentityDefiner idDefiner;
    private final int[] slotMap;

    public CacheLoadCommand(QueryCommand next, IdentityDefiner idDefiner, int[] slotMap) {
        this.next = next;
        this.idDefiner = idDefiner;
        this.slotMap = slotMap;
    }

    public Query getQuery() {
        return next.getQuery();
    }

    public Object execute(InTxCache cache, ResultHandler handler, Row params, Object arg) throws QueryException {
        return next.execute(cache, handler, params, null);
    }
}
