/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

/**
 *
 *
 *
 * @version $Revision: 127 $ $Date: 2004-10-14 21:52:57 -0400 (Thu, 14 Oct 2004) $
 */
public class CacheRowState {
    public static final CacheRowState UNDER_CONSTRUCTION = new CacheRowState("UNDER_CONSTRUCTION");
    public static final CacheRowState NEW = new CacheRowState("NEW");
    public static final CacheRowState CLEAN = new CacheRowState("CLEAN");
    public static final CacheRowState MODIFIED = new CacheRowState("MODIFIED");
    public static final CacheRowState REMOVED = new CacheRowState("REMOVED");

    private final String name;
    
    private CacheRowState(String name) {
        this.name = name;
    }
    
    public String toString() {
        return name;
    }
}
