/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import java.util.HashSet;

import org.tranql.schema.Attribute;

/**
 * 
 * 
 * @version $Revision: 162 $ $Date: 2005-01-22 06:47:21 -0500 (Sat, 22 Jan 2005) $
 */
public class CacheSlot implements Attribute {
    private final boolean identity;
    private final String name;
    private final Class type;
    private final Object defaultValue;

    public CacheSlot(String name, Class type, Object defaultValue, boolean pkField) {
        this.name = name;
        this.type = type;
        this.defaultValue = defaultValue;
        this.identity = pkField;
    }

    public CacheSlot(String name, Class type, Object defaultValue) {
        this.name = name;
        this.type = type;
        this.defaultValue = defaultValue;
        this.identity = false;
    }

    public String getName() {
        return name;
    }

    public String getPhysicalName() {
        return name;
    }

    public Class getType() {
        return type;
    }

    public boolean isIdentity() {
        return identity;
    }

    public Object getDefault() {
        return defaultValue == CacheRow.SET_VALUE ? new HashSet() : defaultValue;
    }
}
