/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import java.util.LinkedHashMap;

import org.tranql.abstractschema.AbstractAssociation;
import org.tranql.schema.Entity;

/**
 * 
 * 
 * @version $Revision: 323 $ $Date: 2006-02-19 01:29:24 -0500 (Sun, 19 Feb 2006) $
 */
public class RelationshipSlot extends AbstractAssociation {

    public RelationshipSlot(JoinDefinition joinDefinition) {
        super(joinDefinition);
    }

    public RelationshipSlot(Entity mtmEntity, JoinDefinition leftDefinition, JoinDefinition rightDefinition) {
        super(mtmEntity, leftDefinition, rightDefinition);
    }
    
    public static class MutableJoinDefinition extends JoinDefinition {
        private Entity pkEntity;
        private Entity fkEntity;

        public MutableJoinDefinition() {
            super(null, null, new LinkedHashMap());
        }

        public void setFKEntity(Entity fkEntity) {
            this.fkEntity = fkEntity;
        }

        public Entity getFKEntity() {
            return fkEntity;
        }

        public void setPKEntity(Entity pkEntity) {
            this.pkEntity = pkEntity;
        }

        public Entity getPKEntity() {
            return pkEntity;
        }

        public LinkedHashMap getPkToFkMapping() {
            throw new UnsupportedOperationException();
        }
    }
}
