/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ddl;



/**
 *
 *
 * @version $Revision: 246 $ $Date: 2005-08-26 22:09:42 -0400 (Fri, 26 Aug 2005) $
 */
public interface DDLVisitor {
    public Object visit(DDL node, Object param) throws DDLException;

    public Object visit(Alter node, Object param) throws DDLException;

    public Object visit(Create node, Object param) throws DDLException;

    public Object visit(ColumnDefinition node, Object param) throws DDLException;

    public Object visit(FKColumnDefinition node, Object param) throws DDLException;

    public Object visit(Constraint node, Object param) throws DDLException;
    
    public Object visit(NodeList node, Object param) throws DDLException;
    
    public Object visit(References node, Object param) throws DDLException;
    
    public Object visit(Drop node, Object param) throws DDLException;
}
