/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import org.tranql.cache.CacheRow;
import org.tranql.cache.InTxCache;
import org.tranql.field.Row;

/**
 *
 *
 *
 * @version $Revision: 185 $ $Date: 2005-05-17 11:38:12 -0400 (Tue, 17 May 2005) $
 */
public class CMPFieldNestedRowAccessor implements CMPFieldTransform {
    private final CMPFieldTransform next;
    private final int slot;

    public CMPFieldNestedRowAccessor(CMPFieldTransform next, int slot) {
        this.next = next;
        this.slot = slot;
    }

    public Object get(InTxCache cache, CacheRow row) {
        Row nestedRow = (Row) next.get(cache, row);
        if ( null == nestedRow ) {
            return null;
        }
        return nestedRow.get(slot);
    }

    public void set(InTxCache cache, CacheRow row, Object value) {
        throw new UnsupportedOperationException();
    }
}
