/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import javax.ejb.EJBLocalObject;
import javax.ejb.EJBObject;

/**
 *
 *
 *
 * @version $Revision: 57 $ $Date: 2004-04-21 17:45:17 -0400 (Wed, 21 Apr 2004) $
 */
public interface EJBProxyFactory {
    /**
     * Return the Class of the local interface
     * @return the local interface class
     */
    Class getLocalInterfaceClass();

    /**
     * Return a local proxy to the specified instance
     * @param pk the id of the instance
     * @return a proxy to that instance
     */
    EJBLocalObject getEJBLocalObject(Object pk);

    /**
     * Return the Class of the remote interface
     * @return the remote interface class
     */
    Class getRemoteInterfaceClass();

    /**
     * Return a remote proxy to the specified instance
     * @param pk the id of the instance
     * @return a proxy to that instance
     */
    EJBObject getEJBObject(Object pk);
}
