/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import javax.ejb.EJBException;

import org.tranql.cache.CacheRow;
import org.tranql.cache.InTxCache;

/**
 *
 *
 *
 * @version $Revision: 185 $ $Date: 2005-05-17 11:38:12 -0400 (Tue, 17 May 2005) $
 */
public class ReadOnlyCMPFieldAccessor implements CMPFieldTransform {
    private final CMPFieldTransform next;
    private final String fieldName;
    
    public ReadOnlyCMPFieldAccessor(CMPFieldTransform next, String fieldName) {
        this.next = next;
        this.fieldName = fieldName;
    }

    public Object get(InTxCache cache, CacheRow row) {
        return next.get(cache, row);
    }

    public void set(InTxCache cache, CacheRow row, Object value) {
        throw new EJBException("cmp-field [" + fieldName + "] is read-only.");
    }
}
