// $ANTLR 2.7.4: "ejbql21.g" -> "EJBQL21Parser.java"$

/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb.parser;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class EJBQL21Parser extends antlr.LLkParser       implements EJBQLTokenTypes
 {

    private static final Log log = LogFactory.getLog(EJBQL21Parser.class);
    private boolean error = false;

    public void reportError(RecognitionException e) {
        error = true;
        log.error(e);
    }

    public void reportError(String s) {
        error = true;
        log.error(s);
    }

    public void reportWarning(String s) {
        log.warn(s);
    }

    public boolean hadErrors() {
        return error;
    }

protected EJBQL21Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public EJBQL21Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected EJBQL21Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public EJBQL21Parser(TokenStream lexer) {
  this(lexer,1);
}

public EJBQL21Parser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void ejbql() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ejbql_AST = null;
		AST select_AST = null;
		AST from_AST = null;
		
		try {      // for error handling
			select_clause();
			select_AST = (AST)returnAST;
			from_clause();
			from_AST = (AST)returnAST;
			{
			switch ( LA(1)) {
			case WHERE:
			{
				where_clause();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case EOF:
			case ORDER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case ORDER:
			{
				orderby_clause();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				ejbql_AST = (AST)currentAST.root;
				ejbql_AST = (AST)astFactory.make( (new ASTArray(4)).add(astFactory.create(EJBQL)).add(from_AST).add(select_AST).add(ejbql_AST));
				currentAST.root = ejbql_AST;
				currentAST.child = ejbql_AST!=null &&ejbql_AST.getFirstChild()!=null ?
					ejbql_AST.getFirstChild() : ejbql_AST;
				currentAST.advanceChildToEnd();
			}
			ejbql_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = ejbql_AST;
	}
	
	public final void select_clause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST select_clause_AST = null;
		
		try {      // for error handling
			AST tmp63_AST = null;
			tmp63_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp63_AST);
			match(SELECT);
			{
			switch ( LA(1)) {
			case DISTINCT:
			{
				AST tmp64_AST = null;
				tmp64_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
				match(DISTINCT);
				break;
			}
			case IDENTIFIER:
			case OBJECT:
			case AVG:
			case MIN:
			case MAX:
			case SUM:
			case COUNT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case OBJECT:
			{
				{
				match(OBJECT);
				match(LPAREN);
				AST tmp67_AST = null;
				tmp67_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp67_AST);
				match(IDENTIFIER);
				match(RPAREN);
				}
				break;
			}
			case IDENTIFIER:
			case AVG:
			case MIN:
			case MAX:
			case SUM:
			case COUNT:
			{
				select_expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			select_clause_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = select_clause_AST;
	}
	
	public final void from_clause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST from_clause_AST = null;
		
		try {      // for error handling
			AST tmp69_AST = null;
			tmp69_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp69_AST);
			match(FROM);
			range_variable_declaration();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop6:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					identification_variable_declaration();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop6;
				}
				
			} while (true);
			}
			from_clause_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = from_clause_AST;
	}
	
	public final void where_clause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST where_clause_AST = null;
		
		try {      // for error handling
			AST tmp71_AST = null;
			tmp71_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp71_AST);
			match(WHERE);
			conditional_expression();
			astFactory.addASTChild(currentAST, returnAST);
			where_clause_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_3);
			} else {
			  throw ex;
			}
		}
		returnAST = where_clause_AST;
	}
	
	public final void orderby_clause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST orderby_clause_AST = null;
		
		try {      // for error handling
			AST tmp72_AST = null;
			tmp72_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp72_AST);
			match(ORDER);
			match(BY);
			path_expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case ASC:
			{
				AST tmp74_AST = null;
				tmp74_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp74_AST);
				match(ASC);
				break;
			}
			case DESC:
			{
				AST tmp75_AST = null;
				tmp75_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp75_AST);
				match(DESC);
				break;
			}
			case EOF:
			case COMMA:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop31:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					path_expression();
					astFactory.addASTChild(currentAST, returnAST);
					{
					switch ( LA(1)) {
					case ASC:
					{
						AST tmp77_AST = null;
						tmp77_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp77_AST);
						match(ASC);
						break;
					}
					case DESC:
					{
						AST tmp78_AST = null;
						tmp78_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp78_AST);
						match(DESC);
						break;
					}
					case EOF:
					case COMMA:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
				}
				else {
					break _loop31;
				}
				
			} while (true);
			}
			orderby_clause_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = orderby_clause_AST;
	}
	
	public final void range_variable_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST range_variable_declaration_AST = null;
		Token  asn = null;
		AST asn_AST = null;
		Token  id = null;
		AST id_AST = null;
		
		try {      // for error handling
			asn = LT(1);
			asn_AST = astFactory.create(asn);
			astFactory.addASTChild(currentAST, asn_AST);
			matchNot(EOF);
			{
			switch ( LA(1)) {
			case AS:
			{
				match(AS);
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			id = LT(1);
			id_AST = astFactory.create(id);
			astFactory.addASTChild(currentAST, id_AST);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				range_variable_declaration_AST = (AST)currentAST.root;
				range_variable_declaration_AST = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(RANGE_VARIABLE)).add(astFactory.create(ABSTRACT_SCHEMA_NAME,asn.getText())).add(id_AST));
				currentAST.root = range_variable_declaration_AST;
				currentAST.child = range_variable_declaration_AST!=null &&range_variable_declaration_AST.getFirstChild()!=null ?
					range_variable_declaration_AST.getFirstChild() : range_variable_declaration_AST;
				currentAST.advanceChildToEnd();
			}
			range_variable_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_4);
			} else {
			  throw ex;
			}
		}
		returnAST = range_variable_declaration_AST;
	}
	
	public final void identification_variable_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST identification_variable_declaration_AST = null;
		
		try {      // for error handling
			boolean synPredMatched9 = false;
			if (((LA(1)==IN))) {
				int _m9 = mark();
				synPredMatched9 = true;
				inputState.guessing++;
				try {
					{
					match(IN);
					match(LPAREN);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched9 = false;
				}
				rewind(_m9);
				inputState.guessing--;
			}
			if ( synPredMatched9 ) {
				collection_member_declaration();
				astFactory.addASTChild(currentAST, returnAST);
				identification_variable_declaration_AST = (AST)currentAST.root;
			}
			else if (((LA(1) >= EJBQL && LA(1) <= EXPONENT))) {
				range_variable_declaration();
				astFactory.addASTChild(currentAST, returnAST);
				identification_variable_declaration_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_4);
			} else {
			  throw ex;
			}
		}
		returnAST = identification_variable_declaration_AST;
	}
	
	public final void collection_member_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST collection_member_declaration_AST = null;
		AST path_AST = null;
		Token  id = null;
		AST id_AST = null;
		
		try {      // for error handling
			match(IN);
			match(LPAREN);
			path_expression();
			path_AST = (AST)returnAST;
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			{
			switch ( LA(1)) {
			case AS:
			{
				match(AS);
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			id = LT(1);
			id_AST = astFactory.create(id);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				collection_member_declaration_AST = (AST)currentAST.root;
				collection_member_declaration_AST = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(COLLECTION_MEMBER)).add(path_AST).add(id_AST));
				currentAST.root = collection_member_declaration_AST;
				currentAST.child = collection_member_declaration_AST!=null &&collection_member_declaration_AST.getFirstChild()!=null ?
					collection_member_declaration_AST.getFirstChild() : collection_member_declaration_AST;
				currentAST.advanceChildToEnd();
			}
			collection_member_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_4);
			} else {
			  throw ex;
			}
		}
		returnAST = collection_member_declaration_AST;
	}
	
	public final void path_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST path_expression_AST = null;
		
		try {      // for error handling
			AST tmp84_AST = null;
			tmp84_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp84_AST);
			match(IDENTIFIER);
			{
			int _cnt86=0;
			_loop86:
			do {
				if ((LA(1)==DOT)) {
					match(DOT);
					AST tmp86_AST = null;
					tmp86_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp86_AST);
					match(IDENTIFIER);
				}
				else {
					if ( _cnt86>=1 ) { break _loop86; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt86++;
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				path_expression_AST = (AST)currentAST.root;
				path_expression_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(PATH,"")).add(path_expression_AST));
				currentAST.root = path_expression_AST;
				currentAST.child = path_expression_AST!=null &&path_expression_AST.getFirstChild()!=null ?
					path_expression_AST.getFirstChild() : path_expression_AST;
				currentAST.advanceChildToEnd();
			}
			path_expression_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = path_expression_AST;
	}
	
	public final void select_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST select_expression_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				path_expression();
				astFactory.addASTChild(currentAST, returnAST);
				select_expression_AST = (AST)currentAST.root;
				break;
			}
			case AVG:
			case MIN:
			case MAX:
			case SUM:
			case COUNT:
			{
				aggregate_expression();
				astFactory.addASTChild(currentAST, returnAST);
				select_expression_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = select_expression_AST;
	}
	
	public final void aggregate_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST aggregate_expression_AST = null;
		
		try {      // for error handling
			if (((LA(1) >= AVG && LA(1) <= SUM))) {
				{
				switch ( LA(1)) {
				case AVG:
				{
					AST tmp87_AST = null;
					tmp87_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp87_AST);
					match(AVG);
					break;
				}
				case MIN:
				{
					AST tmp88_AST = null;
					tmp88_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp88_AST);
					match(MIN);
					break;
				}
				case MAX:
				{
					AST tmp89_AST = null;
					tmp89_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp89_AST);
					match(MAX);
					break;
				}
				case SUM:
				{
					AST tmp90_AST = null;
					tmp90_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp90_AST);
					match(SUM);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(LPAREN);
				{
				switch ( LA(1)) {
				case DISTINCT:
				{
					AST tmp92_AST = null;
					tmp92_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp92_AST);
					match(DISTINCT);
					break;
				}
				case IDENTIFIER:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				path_expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				aggregate_expression_AST = (AST)currentAST.root;
			}
			else {
				boolean synPredMatched24 = false;
				if (((LA(1)==COUNT))) {
					int _m24 = mark();
					synPredMatched24 = true;
					inputState.guessing++;
					try {
						{
						match(COUNT);
						match(LPAREN);
						{
						switch ( LA(1)) {
						case DISTINCT:
						{
							match(DISTINCT);
							break;
						}
						case IDENTIFIER:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						match(IDENTIFIER);
						match(RPAREN);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched24 = false;
					}
					rewind(_m24);
					inputState.guessing--;
				}
				if ( synPredMatched24 ) {
					AST tmp94_AST = null;
					tmp94_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp94_AST);
					match(COUNT);
					match(LPAREN);
					{
					switch ( LA(1)) {
					case DISTINCT:
					{
						AST tmp96_AST = null;
						tmp96_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp96_AST);
						match(DISTINCT);
						break;
					}
					case IDENTIFIER:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					AST tmp97_AST = null;
					tmp97_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp97_AST);
					match(IDENTIFIER);
					match(RPAREN);
					aggregate_expression_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==COUNT)) {
					AST tmp99_AST = null;
					tmp99_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp99_AST);
					match(COUNT);
					match(LPAREN);
					{
					switch ( LA(1)) {
					case DISTINCT:
					{
						AST tmp101_AST = null;
						tmp101_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp101_AST);
						match(DISTINCT);
						break;
					}
					case IDENTIFIER:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					path_expression();
					astFactory.addASTChild(currentAST, returnAST);
					match(RPAREN);
					aggregate_expression_AST = (AST)currentAST.root;
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					consume();
					consumeUntil(_tokenSet_1);
				} else {
				  throw ex;
				}
			}
			returnAST = aggregate_expression_AST;
		}
		
	public final void conditional_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST conditional_expression_AST = null;
		
		try {      // for error handling
			and_expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop35:
			do {
				if ((LA(1)==OR)) {
					AST tmp103_AST = null;
					tmp103_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp103_AST);
					match(OR);
					and_expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop35;
				}
				
			} while (true);
			}
			conditional_expression_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_6);
			} else {
			  throw ex;
			}
		}
		returnAST = conditional_expression_AST;
	}
	
	public final void and_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST and_expression_AST = null;
		
		try {      // for error handling
			not_expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop38:
			do {
				if ((LA(1)==AND)) {
					AST tmp104_AST = null;
					tmp104_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp104_AST);
					match(AND);
					not_expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop38;
				}
				
			} while (true);
			}
			and_expression_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = and_expression_AST;
	}
	
	public final void not_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST not_expression_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case NOT:
			{
				AST tmp105_AST = null;
				tmp105_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp105_AST);
				match(NOT);
				break;
			}
			case LPAREN:
			case IDENTIFIER:
			case PLUS:
			case MINUS:
			case INPUT_PARAM:
			case STRING_LITERAL:
			case CONCAT:
			case SUBSTRING:
			case LENGTH:
			case LOCATE:
			case ABS:
			case SQRT:
			case MOD:
			case INTEGER_LITERAL:
			case FLOAT_LITERAL:
			case TRUE:
			case FALSE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			boolean_expression();
			astFactory.addASTChild(currentAST, returnAST);
			not_expression_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		returnAST = not_expression_AST;
	}
	
	public final void boolean_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST boolean_expression_AST = null;
		
		try {      // for error handling
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop78:
			do {
				if ((_tokenSet_9.member(LA(1)))) {
					{
					switch ( LA(1)) {
					case EQ:
					case NE:
					case LT:
					case LE:
					case GT:
					case GE:
					{
						{
						switch ( LA(1)) {
						case EQ:
						{
							AST tmp106_AST = null;
							tmp106_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp106_AST);
							match(EQ);
							break;
						}
						case NE:
						{
							AST tmp107_AST = null;
							tmp107_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp107_AST);
							match(NE);
							break;
						}
						case LT:
						{
							AST tmp108_AST = null;
							tmp108_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp108_AST);
							match(LT);
							break;
						}
						case LE:
						{
							AST tmp109_AST = null;
							tmp109_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp109_AST);
							match(LE);
							break;
						}
						case GT:
						{
							AST tmp110_AST = null;
							tmp110_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp110_AST);
							match(GT);
							break;
						}
						case GE:
						{
							AST tmp111_AST = null;
							tmp111_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp111_AST);
							match(GE);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						expression();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case PLUS:
					case MINUS:
					case MULT:
					case DIV:
					{
						{
						switch ( LA(1)) {
						case PLUS:
						{
							AST tmp112_AST = null;
							tmp112_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp112_AST);
							match(PLUS);
							break;
						}
						case MINUS:
						{
							AST tmp113_AST = null;
							tmp113_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp113_AST);
							match(MINUS);
							break;
						}
						case MULT:
						{
							AST tmp114_AST = null;
							tmp114_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp114_AST);
							match(MULT);
							break;
						}
						case DIV:
						{
							AST tmp115_AST = null;
							tmp115_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp115_AST);
							match(DIV);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						expression();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					default:
						boolean synPredMatched48 = false;
						if (((LA(1)==NOT||LA(1)==BETWEEN))) {
							int _m48 = mark();
							synPredMatched48 = true;
							inputState.guessing++;
							try {
								{
								{
								switch ( LA(1)) {
								case NOT:
								{
									match(NOT);
									break;
								}
								case BETWEEN:
								{
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1), getFilename());
								}
								}
								}
								match(BETWEEN);
								}
							}
							catch (RecognitionException pe) {
								synPredMatched48 = false;
							}
							rewind(_m48);
							inputState.guessing--;
						}
						if ( synPredMatched48 ) {
							{
							switch ( LA(1)) {
							case NOT:
							{
								AST tmp116_AST = null;
								tmp116_AST = astFactory.create(LT(1));
								astFactory.addASTChild(currentAST, tmp116_AST);
								match(NOT);
								break;
							}
							case BETWEEN:
							{
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							AST tmp117_AST = null;
							tmp117_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp117_AST);
							match(BETWEEN);
							expression();
							astFactory.addASTChild(currentAST, returnAST);
							match(AND);
							expression();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							boolean synPredMatched52 = false;
							if (((LA(1)==IN||LA(1)==NOT))) {
								int _m52 = mark();
								synPredMatched52 = true;
								inputState.guessing++;
								try {
									{
									{
									switch ( LA(1)) {
									case NOT:
									{
										match(NOT);
										break;
									}
									case IN:
									{
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1), getFilename());
									}
									}
									}
									match(IN);
									}
								}
								catch (RecognitionException pe) {
									synPredMatched52 = false;
								}
								rewind(_m52);
								inputState.guessing--;
							}
							if ( synPredMatched52 ) {
								{
								switch ( LA(1)) {
								case NOT:
								{
									AST tmp119_AST = null;
									tmp119_AST = astFactory.create(LT(1));
									astFactory.addASTChild(currentAST, tmp119_AST);
									match(NOT);
									break;
								}
								case IN:
								{
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1), getFilename());
								}
								}
								}
								AST tmp120_AST = null;
								tmp120_AST = astFactory.create(LT(1));
								astFactory.makeASTRoot(currentAST, tmp120_AST);
								match(IN);
								match(LPAREN);
								{
								switch ( LA(1)) {
								case STRING_LITERAL:
								case INTEGER_LITERAL:
								case FLOAT_LITERAL:
								case TRUE:
								case FALSE:
								{
									literal();
									astFactory.addASTChild(currentAST, returnAST);
									break;
								}
								case INPUT_PARAM:
								{
									AST tmp122_AST = null;
									tmp122_AST = astFactory.create(LT(1));
									astFactory.addASTChild(currentAST, tmp122_AST);
									match(INPUT_PARAM);
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1), getFilename());
								}
								}
								}
								{
								_loop57:
								do {
									if ((LA(1)==COMMA)) {
										match(COMMA);
										{
										switch ( LA(1)) {
										case STRING_LITERAL:
										case INTEGER_LITERAL:
										case FLOAT_LITERAL:
										case TRUE:
										case FALSE:
										{
											literal();
											astFactory.addASTChild(currentAST, returnAST);
											break;
										}
										case INPUT_PARAM:
										{
											AST tmp124_AST = null;
											tmp124_AST = astFactory.create(LT(1));
											astFactory.addASTChild(currentAST, tmp124_AST);
											match(INPUT_PARAM);
											break;
										}
										default:
										{
											throw new NoViableAltException(LT(1), getFilename());
										}
										}
										}
									}
									else {
										break _loop57;
									}
									
								} while (true);
								}
								match(RPAREN);
							}
							else {
								boolean synPredMatched60 = false;
								if (((LA(1)==NOT||LA(1)==LIKE))) {
									int _m60 = mark();
									synPredMatched60 = true;
									inputState.guessing++;
									try {
										{
										{
										switch ( LA(1)) {
										case NOT:
										{
											match(NOT);
											break;
										}
										case LIKE:
										{
											break;
										}
										default:
										{
											throw new NoViableAltException(LT(1), getFilename());
										}
										}
										}
										match(LIKE);
										}
									}
									catch (RecognitionException pe) {
										synPredMatched60 = false;
									}
									rewind(_m60);
									inputState.guessing--;
								}
								if ( synPredMatched60 ) {
									{
									switch ( LA(1)) {
									case NOT:
									{
										AST tmp126_AST = null;
										tmp126_AST = astFactory.create(LT(1));
										astFactory.addASTChild(currentAST, tmp126_AST);
										match(NOT);
										break;
									}
									case LIKE:
									{
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1), getFilename());
									}
									}
									}
									AST tmp127_AST = null;
									tmp127_AST = astFactory.create(LT(1));
									astFactory.makeASTRoot(currentAST, tmp127_AST);
									match(LIKE);
									{
									switch ( LA(1)) {
									case STRING_LITERAL:
									{
										AST tmp128_AST = null;
										tmp128_AST = astFactory.create(LT(1));
										astFactory.addASTChild(currentAST, tmp128_AST);
										match(STRING_LITERAL);
										break;
									}
									case INPUT_PARAM:
									{
										AST tmp129_AST = null;
										tmp129_AST = astFactory.create(LT(1));
										astFactory.addASTChild(currentAST, tmp129_AST);
										match(INPUT_PARAM);
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1), getFilename());
									}
									}
									}
									{
									switch ( LA(1)) {
									case ESCAPE:
									{
										match(ESCAPE);
										{
										switch ( LA(1)) {
										case STRING_LITERAL:
										{
											AST tmp131_AST = null;
											tmp131_AST = astFactory.create(LT(1));
											astFactory.addASTChild(currentAST, tmp131_AST);
											match(STRING_LITERAL);
											break;
										}
										case INPUT_PARAM:
										{
											AST tmp132_AST = null;
											tmp132_AST = astFactory.create(LT(1));
											astFactory.addASTChild(currentAST, tmp132_AST);
											match(INPUT_PARAM);
											break;
										}
										default:
										{
											throw new NoViableAltException(LT(1), getFilename());
										}
										}
										}
										break;
									}
									case EOF:
									case IN:
									case RPAREN:
									case ORDER:
									case OR:
									case AND:
									case NOT:
									case EQ:
									case NE:
									case LT:
									case LE:
									case GT:
									case GE:
									case PLUS:
									case MINUS:
									case MULT:
									case DIV:
									case BETWEEN:
									case LIKE:
									case IS:
									case MEMBER:
									{
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1), getFilename());
									}
									}
									}
								}
								else {
									boolean synPredMatched67 = false;
									if (((LA(1)==IS))) {
										int _m67 = mark();
										synPredMatched67 = true;
										inputState.guessing++;
										try {
											{
											match(IS);
											{
											switch ( LA(1)) {
											case NOT:
											{
												match(NOT);
												break;
											}
											case EMPTY:
											{
												break;
											}
											default:
											{
												throw new NoViableAltException(LT(1), getFilename());
											}
											}
											}
											match(EMPTY);
											}
										}
										catch (RecognitionException pe) {
											synPredMatched67 = false;
										}
										rewind(_m67);
										inputState.guessing--;
									}
									if ( synPredMatched67 ) {
										match(IS);
										{
										switch ( LA(1)) {
										case NOT:
										{
											AST tmp134_AST = null;
											tmp134_AST = astFactory.create(LT(1));
											astFactory.addASTChild(currentAST, tmp134_AST);
											match(NOT);
											break;
										}
										case EMPTY:
										{
											break;
										}
										default:
										{
											throw new NoViableAltException(LT(1), getFilename());
										}
										}
										}
										AST tmp135_AST = null;
										tmp135_AST = astFactory.create(LT(1));
										astFactory.makeASTRoot(currentAST, tmp135_AST);
										match(EMPTY);
									}
									else {
										boolean synPredMatched71 = false;
										if (((LA(1)==IS))) {
											int _m71 = mark();
											synPredMatched71 = true;
											inputState.guessing++;
											try {
												{
												match(IS);
												{
												switch ( LA(1)) {
												case NOT:
												{
													match(NOT);
													break;
												}
												case NULL:
												{
													break;
												}
												default:
												{
													throw new NoViableAltException(LT(1), getFilename());
												}
												}
												}
												match(NULL);
												}
											}
											catch (RecognitionException pe) {
												synPredMatched71 = false;
											}
											rewind(_m71);
											inputState.guessing--;
										}
										if ( synPredMatched71 ) {
											match(IS);
											{
											switch ( LA(1)) {
											case NOT:
											{
												AST tmp137_AST = null;
												tmp137_AST = astFactory.create(LT(1));
												astFactory.addASTChild(currentAST, tmp137_AST);
												match(NOT);
												break;
											}
											case NULL:
											{
												break;
											}
											default:
											{
												throw new NoViableAltException(LT(1), getFilename());
											}
											}
											}
											AST tmp138_AST = null;
											tmp138_AST = astFactory.create(LT(1));
											astFactory.makeASTRoot(currentAST, tmp138_AST);
											match(NULL);
										}
										else {
											boolean synPredMatched75 = false;
											if (((LA(1)==NOT||LA(1)==MEMBER))) {
												int _m75 = mark();
												synPredMatched75 = true;
												inputState.guessing++;
												try {
													{
													{
													switch ( LA(1)) {
													case NOT:
													{
														match(NOT);
														break;
													}
													case MEMBER:
													{
														break;
													}
													default:
													{
														throw new NoViableAltException(LT(1), getFilename());
													}
													}
													}
													match(MEMBER);
													}
												}
												catch (RecognitionException pe) {
													synPredMatched75 = false;
												}
												rewind(_m75);
												inputState.guessing--;
											}
											if ( synPredMatched75 ) {
												{
												switch ( LA(1)) {
												case NOT:
												{
													AST tmp139_AST = null;
													tmp139_AST = astFactory.create(LT(1));
													astFactory.addASTChild(currentAST, tmp139_AST);
													match(NOT);
													break;
												}
												case MEMBER:
												{
													break;
												}
												default:
												{
													throw new NoViableAltException(LT(1), getFilename());
												}
												}
												}
												AST tmp140_AST = null;
												tmp140_AST = astFactory.create(LT(1));
												astFactory.makeASTRoot(currentAST, tmp140_AST);
												match(MEMBER);
												{
												switch ( LA(1)) {
												case OF:
												{
													match(OF);
													break;
												}
												case IDENTIFIER:
												{
													break;
												}
												default:
												{
													throw new NoViableAltException(LT(1), getFilename());
												}
												}
												}
												path_expression();
												astFactory.addASTChild(currentAST, returnAST);
											}
										else {
											throw new NoViableAltException(LT(1), getFilename());
										}
										}}}}}}
										}
									}
									else {
										break _loop78;
									}
									
								} while (true);
								}
								boolean_expression_AST = (AST)currentAST.root;
							}
							catch (RecognitionException ex) {
								if (inputState.guessing==0) {
									reportError(ex);
									consume();
									consumeUntil(_tokenSet_8);
								} else {
								  throw ex;
								}
							}
							returnAST = boolean_expression_AST;
						}
						
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_AST = null;
		AST v1_AST = null;
		AST v2_AST = null;
		AST v3_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LPAREN:
			{
				match(LPAREN);
				conditional_expression();
				v1_AST = (AST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					expression_AST = (AST)currentAST.root;
					expression_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EXPLICIT_BRACKETING)).add(v1_AST));
					currentAST.root = expression_AST;
					currentAST.child = expression_AST!=null &&expression_AST.getFirstChild()!=null ?
						expression_AST.getFirstChild() : expression_AST;
					currentAST.advanceChildToEnd();
				}
				expression_AST = (AST)currentAST.root;
				break;
			}
			case IDENTIFIER:
			case CONCAT:
			case SUBSTRING:
			case LENGTH:
			case LOCATE:
			case ABS:
			case SQRT:
			case MOD:
			{
				value();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
				break;
			}
			case STRING_LITERAL:
			case INTEGER_LITERAL:
			case FLOAT_LITERAL:
			case TRUE:
			case FALSE:
			{
				literal();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
				break;
			}
			case INPUT_PARAM:
			{
				AST tmp144_AST = null;
				tmp144_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp144_AST);
				match(INPUT_PARAM);
				expression_AST = (AST)currentAST.root;
				break;
			}
			case PLUS:
			{
				match(PLUS);
				expression();
				v2_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					expression_AST = (AST)currentAST.root;
					expression_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(UNARY_PLUS)).add(v2_AST));
					currentAST.root = expression_AST;
					currentAST.child = expression_AST!=null &&expression_AST.getFirstChild()!=null ?
						expression_AST.getFirstChild() : expression_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			case MINUS:
			{
				match(MINUS);
				expression();
				v3_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					expression_AST = (AST)currentAST.root;
					expression_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(UNARY_MINUS)).add(v3_AST));
					currentAST.root = expression_AST;
					currentAST.child = expression_AST!=null &&expression_AST.getFirstChild()!=null ?
						expression_AST.getFirstChild() : expression_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = expression_AST;
	}
	
	public final void literal() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST literal_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				AST tmp147_AST = null;
				tmp147_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp147_AST);
				match(STRING_LITERAL);
				literal_AST = (AST)currentAST.root;
				break;
			}
			case INTEGER_LITERAL:
			{
				AST tmp148_AST = null;
				tmp148_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp148_AST);
				match(INTEGER_LITERAL);
				literal_AST = (AST)currentAST.root;
				break;
			}
			case FLOAT_LITERAL:
			{
				AST tmp149_AST = null;
				tmp149_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp149_AST);
				match(FLOAT_LITERAL);
				literal_AST = (AST)currentAST.root;
				break;
			}
			case TRUE:
			{
				AST tmp150_AST = null;
				tmp150_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp150_AST);
				match(TRUE);
				literal_AST = (AST)currentAST.root;
				break;
			}
			case FALSE:
			{
				AST tmp151_AST = null;
				tmp151_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp151_AST);
				match(FALSE);
				literal_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = literal_AST;
	}
	
	public final void value() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST value_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case CONCAT:
			{
				AST tmp152_AST = null;
				tmp152_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp152_AST);
				match(CONCAT);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case SUBSTRING:
			{
				AST tmp156_AST = null;
				tmp156_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp156_AST);
				match(SUBSTRING);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case LENGTH:
			{
				AST tmp161_AST = null;
				tmp161_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp161_AST);
				match(LENGTH);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case LOCATE:
			{
				AST tmp164_AST = null;
				tmp164_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp164_AST);
				match(LOCATE);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case COMMA:
				{
					match(COMMA);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case ABS:
			{
				AST tmp169_AST = null;
				tmp169_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp169_AST);
				match(ABS);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case SQRT:
			{
				AST tmp172_AST = null;
				tmp172_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp172_AST);
				match(SQRT);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			case MOD:
			{
				AST tmp175_AST = null;
				tmp175_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp175_AST);
				match(MOD);
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				value_AST = (AST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched82 = false;
				if (((LA(1)==IDENTIFIER))) {
					int _m82 = mark();
					synPredMatched82 = true;
					inputState.guessing++;
					try {
						{
						match(IDENTIFIER);
						match(DOT);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched82 = false;
					}
					rewind(_m82);
					inputState.guessing--;
				}
				if ( synPredMatched82 ) {
					path_expression();
					astFactory.addASTChild(currentAST, returnAST);
					value_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==IDENTIFIER)) {
					AST tmp179_AST = null;
					tmp179_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp179_AST);
					match(IDENTIFIER);
					value_AST = (AST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = value_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"EJBQL",
		"RANGE_VARIABLE",
		"COLLECTION_MEMBER",
		"ABSTRACT_SCHEMA_NAME",
		"PATH",
		"\"from\"",
		"COMMA",
		"\"in\"",
		"LPAREN",
		"\"as\"",
		"an identifier",
		"RPAREN",
		"\"select\"",
		"\"distinct\"",
		"\"object\"",
		"\"avg\"",
		"\"min\"",
		"\"max\"",
		"\"sum\"",
		"\"count\"",
		"\"order\"",
		"\"by\"",
		"\"asc\"",
		"\"desc\"",
		"\"where\"",
		"\"or\"",
		"\"and\"",
		"\"not\"",
		"EQ",
		"NE",
		"LT",
		"LE",
		"GT",
		"GE",
		"PLUS",
		"MINUS",
		"MULT",
		"DIV",
		"\"between\"",
		"an input parameter",
		"\"like\"",
		"a string literal",
		"\"escape\"",
		"\"is\"",
		"\"empty\"",
		"\"null\"",
		"\"member\"",
		"\"of\"",
		"DOT",
		"\"concat\"",
		"\"substring\"",
		"\"length\"",
		"\"locate\"",
		"\"abs\"",
		"\"sqrt\"",
		"\"mod\"",
		"an integer literal",
		"FLOAT_LITERAL",
		"\"true\"",
		"\"false\"",
		"EXPLICIT_BRACKETING",
		"UNARY_PLUS",
		"UNARY_MINUS",
		"\"unknown\"",
		"WS",
		"QUESTION",
		"DIGIT",
		"OCTAL_DIGIT",
		"HEX_DIGIT",
		"INTEGER_SUFFIX",
		"FLOAT_SUFFIX",
		"EXPONENT"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 512L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 285212674L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 16777218L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 285213698L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 1293025355533826L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 16809986L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 553680898L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 1627422722L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 1293023526782976L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 1293025154206722L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	
	}
