/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejbqlcompiler;

import org.tranql.ql.QueryException;
import org.tranql.ql.QuerySource;
import org.tranql.ql.QuerySourceDictionary;

/**
 * This visitor registers the QuerySources defined by the query.
 * 
 * @version $Revision: 186 $ $Date: 2005-06-22 07:22:41 -0400 (Wed, 22 Jun 2005) $
 */
class QuerySourceRegister extends InterRepresentationTransformer {
    
    public QuerySourceRegister(QuerySourceDictionary sourceDictionary) {
        super(sourceDictionary);
    }

    public Object visit(QuerySource node, Object param) throws QueryException {
    	QuerySourceDictionary sourceDictionary = (QuerySourceDictionary) param;
    	sourceDictionary.registerQuerySource(new QuerySource(node.getEntity(), node.getAlias(), node.isForUpdate()));
        return super.visit(node, param);
    }

}
