/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.field;


/**
 *
 * @version $Revision: 127 $ $Date: 2004-10-14 21:52:57 -0400 (Thu, 14 Oct 2004) $
 */
public class NestedRowAccessor implements FieldTransform {
    private final FieldTransform next;
    private final Class fieldClass;
    private final int slot;

    public NestedRowAccessor(FieldTransform next, int slot, Class fieldClass) {
        this.next = next;
        this.slot = slot;
        this.fieldClass = fieldClass;
    }

    public Class getFieldClass() {
        return fieldClass;
    }

    public Object get(Row row) throws FieldTransformException {
        Row nestedRow = (Row) next.get(row);
        if ( null == nestedRow ) {
            return null;
        }
        return nestedRow.get(slot);
    }

    public void set(Row row, Object value) {
        throw new UnsupportedOperationException();
    }
}
