/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.field;

/**
 *
 *
 *
 * @version $Revision: 11 $ $Date: 2004-03-19 06:39:41 -0500 (Fri, 19 Mar 2004) $
 */
public class Row {
    protected final Object[] values;

    public Row(Object[] values) {
        this.values = values;
    }

    public final Object[] getValues() {
        return values;
    }

    public final Object get(int slot) {
        return values[slot];
    }

    public final void set(int slot, Object value) {
        values[slot] = value;
    }
}
