/**
 * 
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.intertxcache;

import java.util.Collection;

import javax.transaction.Transaction;

import org.tranql.cache.CacheRow;
import org.tranql.identity.GlobalIdentity;

/**
 *
 * @version $Revision: 323 $ $Date: 2006-02-19 01:29:24 -0500 (Sun, 19 Feb 2006) $
 */
public class NoOpCache implements Cache {
    public static final NoOpCache SINGLETON = new NoOpCache();
    
    private NoOpCache() {
    }
    
    public void transactionStart(Transaction tx) throws CacheException {
    }

    public void transactionEnd(Transaction tx, int status, Collection rows) throws CacheException {
    }

    public void put(Transaction tx, CacheRow row) throws CacheException {
    }

    public void set(Transaction tx, CacheRow row, int[] indices) throws CacheException {
    }

    public CacheRow get(Transaction tx, GlobalIdentity id) throws CacheException {
        return null;
    }

    public boolean get(Transaction tx, CacheRow target, int[] indices) throws CacheException {
        return false;
    }

    public void remove(Transaction tx, GlobalIdentity id) throws CacheException {
    }

    public void release(GlobalIdentity id) throws CacheException {
    }

    public void clean() {
    }
}