/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;

/**
 * This node represents an assignment in an update statement.
 * This node expects two children a left value, expression or
 * literal and a right value, expression or literal.
 *
 * Note: this class is only used in update queries, and explicitly
 * this class is *not* used in a where clause for equals companison.
 * For that casue use a BinaryOperation node.
 *
 * todo exactally what type of children are valid
 *
 * leftVariable = rightValue
 *
 * @version $Revision: 138 $ $Date: 2004-10-20 23:52:45 -0400 (Wed, 20 Oct 2004) $
 */
public class Assignment extends AbstractNode {
    public Object visit(QueryVisitor visitor, Object param) throws QueryException {
        return visitor.visit(this, param);
    }
}
