/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;



/**
 * This node represents a no-op query.
 *
 * @version $Revision: 155 $ $Date: 2004-12-02 18:12:10 -0500 (Thu, 02 Dec 2004) $
 */
public class NoOpQuery extends Query {
    private static final QueryBinding[] EMPTY_FIELD_TRANSFORM = new QueryBinding[0];
    
    public static final Query NO_OP_QUERY = new NoOpQuery();
    
    private NoOpQuery() {
        super(EMPTY_FIELD_TRANSFORM, EMPTY_FIELD_TRANSFORM);
    }
    
    public void setSibling(Node sibling) {
        throw new UnsupportedOperationException();
    }

    public Node addChild(Node child) {
        throw new UnsupportedOperationException();
    }
    
    public Object visit(QueryVisitor visitor, Object param) throws QueryException {
        return NO_OP_QUERY;
    }
}
