/**
 *
 *  Copyright 2004 Dain Sundstrom
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;

import org.tranql.schema.Attribute;
import org.tranql.schema.Entity;
import org.tranql.schema.FKAttribute;

/**
 * @version $Revision: 155 $ $Date: 2004-12-02 18:12:10 -0500 (Thu, 02 Dec 2004) $
 */
public interface SchemaBinding {
    public void setEntity(Entity entity);

    public Entity getEntity();
    
    public boolean isAttributeBinding();

    public void setAttribute(Attribute attribute);
    
    public Attribute getAttribute();

    public boolean isFKAttributeBinding();

    public void setFKAttribute(FKAttribute fkAttribute);
    
    public FKAttribute getFKAttribute();

    public boolean isUnknownBinding();
}