/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;

import java.io.Serializable;


/**
 *
 * @version $Revision: 163 $ $Date: 2005-01-30 01:10:22 -0500 (Sun, 30 Jan 2005) $
 */
public class UnaryOperator extends AbstractNode {
    public static final UnaryOperatorType PLUS = new UnaryOperatorType();
    public static final UnaryOperatorType MINUS = new UnaryOperatorType();
    
    public static final class UnaryOperatorType implements Serializable {
        private UnaryOperatorType() {}
    }
    
    private final UnaryOperatorType type; 
    
    public UnaryOperator(UnaryOperatorType type) {
        this.type = type;
    }

    public UnaryOperatorType getType() {
        return type;
    }
    
    public Object visit(QueryVisitor visitor, Object param) throws QueryException {
        return visitor.visit(this, param);
    }

}
