/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;

import org.tranql.schema.Entity;

/**
 * This subclass is used to identify the entity type that will be
 * updated using an update query. 
 *
 * @version $Revision: 133 $ $Date: 2004-10-19 16:42:06 -0400 (Tue, 19 Oct 2004) $
 */
public class Update extends AliasedEntity {
    public Update(Entity entity) {
        super(entity, entity.getName().substring(0, 1));
    }

    public Object visit(QueryVisitor visitor, Object param) throws QueryException {
        return visitor.visit(this, param);
    }
}
