/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql.queryvisitor;

import org.tranql.ql.Node;
import org.tranql.ql.QueryException;

/**
 *
 *
 * @version $Revision: 157 $ $Date: 2004-12-09 19:30:51 -0500 (Thu, 09 Dec 2004) $
 */
public class UnsupportedVisitNodeExecutor implements NodeExecutor {
    public static final NodeExecutor NODE_EXECUTOR = new UnsupportedVisitNodeExecutor();
    
    private UnsupportedVisitNodeExecutor() {}
    
    public Object execute(Node node, Object param) throws QueryException {
        throw new UnsupportedOperationException();
    }
}