/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.schema;

import java.util.List;
import java.io.Serializable;

/**
 *
 *
 * @version $Revision: 185 $ $Date: 2005-05-17 11:38:12 -0400 (Tue, 17 May 2005) $
 */
public interface Entity extends Serializable {
    String getName();

    String getPhysicalName();

    Attribute getAttribute(String name);

    List getPrimaryKeyFields();

    List getAttributes();

    AssociationEnd getAssociationEnd(String name);

    AssociationEnd getAssociationEndDefiningFKAttribute(String fkAttribute);

    List getAssociationEnds();
}
