/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.schema;

import java.io.Serializable;
import java.util.Map;

import org.tranql.query.CommandFactory;

/**
 *
 *
 * @version $Revision: 161 $ $Date: 2005-01-07 01:37:34 -0500 (Fri, 07 Jan 2005) $
 */
public interface Schema extends Serializable {
    String getName();

    String getPhysicalName();

    Entity getEntity(String name);
    
    Entity getEntityByPhysicalName(String physicalName);

    Map getEntities();
    
    CommandFactory getCommandFactory();
}
