/**
 *
 *  Copyright 2004 Dain Sundstrom
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.sql;

import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;

import org.tranql.query.ConnectionFactoryDelegate;

/**
 * @version $Revision: 305 $ $Date: 2005-12-11 01:46:02 -0500 (Sun, 11 Dec 2005) $
 */
public class DataSourceDelegate implements DataSource, ConnectionFactoryDelegate {
    private transient DataSource delegate;

    public void setConnectionFactory(Object connectionFactory) {
        delegate = (DataSource) connectionFactory;
    }

    public Connection getConnection() throws SQLException {
        if (delegate==null) {
          throw new IllegalStateException("Reqested Database Connection Pool cannot be found");
        }
        return delegate.getConnection();
    }

    public Connection getConnection(String username, String password)
      throws SQLException {
        return delegate.getConnection(username, password);
    }

    public java.io.PrintWriter getLogWriter() throws SQLException {
        return delegate.getLogWriter();
    }

    public void setLogWriter(java.io.PrintWriter out) throws SQLException {
        delegate.setLogWriter(out);
    }

    public void setLoginTimeout(int seconds) throws SQLException {
        delegate.setLoginTimeout(seconds);
    }

    public int getLoginTimeout() throws SQLException {
        return delegate.getLoginTimeout();
    }
}
