/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.sql.jdbc;

import org.tranql.cache.InTxCache;
import org.tranql.field.Row;
import org.tranql.ql.NoOpQuery;
import org.tranql.ql.Query;
import org.tranql.ql.QueryException;
import org.tranql.query.UpdateCommand;

/**
 *
 *
 *
 * @version $Revision: 142 $ $Date: 2004-11-07 03:01:22 -0500 (Sun, 07 Nov 2004) $
 */
public class NoOpJDBCUpdateCommand implements UpdateCommand {
    public Query getQuery() {
        return NoOpQuery.NO_OP_QUERY;
    }

    public String getSQLText() {
        return "";
    }

    public int execute(InTxCache cache, Row row) throws QueryException {
        return 0;
    }
}
